//
//  SLUserModel.m
//  SLAiELTS
//
//  Created by Gusont on 2023/3/1.
//

#import "SLUserModel.h"

@interface SLUserModel()

///
@property (nonatomic, strong) NSString * name;

///
@property (nonatomic, strong) NSString * head;

@end

@implementation SLUserModel

+ (NSDictionary *)mj_replacedKeyFromPropertyName {
   return @{
            @"userId" : @"id"};
}

- (void)setHead:(NSString *)head {
    _head = head;
    _userHead = head;
}

- (void)setName:(NSString *)name {
    _name = name;
    _userName = name;
}

+ (void)requestUserInterest {
    [[SLHttpCenter SharedInstance] getWithUrl:@"/api/User/GetUserInterest" parameter:@{} success:^(id responseObject) {
        NSArray *interestList = [responseObject objectForKey:@"data"];
        NSArray *interestListModel = [InterestModel mj_objectArrayWithKeyValuesArray:interestList];
        [SLGlobalInfo SharedInstance].loginInfo.user.interestsArr = interestListModel;
    } failure:^(SPRequestError *error) {
        
    }];
}

+ (void)requestUserRoleModel {
    NSString *userId = [SLGlobalInfo SharedInstance].loginInfo.user.userId;
    if (userId) {
        [[SLHttpCenter SharedInstance] getWithUrl:@"/api/User/GetAssistantInfo" parameter:@{} success:^(id responseObject) {
            NSDictionary *dict = [responseObject objectForKey:@"data"];
            if ([dict isKindOfClass:NSDictionary.class]) {
                [SLGlobalInfo SharedInstance].roleModel = [RoleModel mj_objectWithKeyValues:dict];
            }
        } failure:^(SPRequestError *error) {
            
        }];
    }
}

- (NSString *)getUserHeadUrl {
    NSString *userImg = [NSString stringWithFormat:@"%@%@",[SLHttpCenter SharedInstance].serverUrl, self.userHead];
    return userImg;
}

@end
