//
//  YMChatServiceView.m
//  PCDBank
//
//  Created by Gusont on 2021/8/26.
//  Copyright © 2021 SLAiELTS. All rights reserved.
//

#import "YMChatServiceView.h"
#import "MessageModel.h"
#import "SLMikeInputView.h"
#import "SLMikeSegmentModel.h"

@interface YMChatServiceView()<Delegates>

@property (nonatomic, strong) NSMutableString *recResultString;

@end

@implementation YMChatServiceView

- (void)dealloc
{

}

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self confignUI];
    }
    return self;
}

- (void)confignUI
{
//    if ([SLGlobalInfo SharedInstance].loginInfo.user.userMsgBg.length) {
//        UIImageView *imageView = [[UIImageView alloc] initWithFrame:CGRectZero];
//        NSString *userImg = [NSString stringWithFormat:@"%@%@",[SLHttpCenter SharedInstance].serverUrl, [SLGlobalInfo SharedInstance].loginInfo.user.userMsgBg];
//        [imageView sd_setImageWithURL:[NSURL URLWithString:userImg]];
//        imageView.contentMode = UIViewContentModeScaleAspectFill;
//        imageView.clipsToBounds = YES;
//        [self addSubview:imageView];
//        [imageView mas_makeConstraints:^(MASConstraintMaker *make) {
//            make.edges.equalTo(self.messageView);
//        }];
//    }
    
    CGFloat bottomHeight = 56 + kSafeAreaBottom;
    self.messageView.messageCollectionView.contentInset = UIEdgeInsetsMake(0, 0, 32, 0);
    
    [self.messageView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.equalTo(self);
        make.bottom.equalTo(self.chatBottomView.mas_top).offset(0);
    }];
    self.messageView.backgroundColor = [UIColor clearColor];
    
    
    [self.chatBottomView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self);
        make.height.mas_equalTo(bottomHeight + 80);
        make.bottom.equalTo(self.mas_bottom).offset(-0);
//        make.top.equalTo(self.mas_bottom).offset(-bottomHeight);
    }];

    WS(weakSelf);
    self.chatBottomView.sendTextBlock = ^(NSString * _Nonnull text) {
        if (text.length) {
            MessageModel *model = [MessageModel initWithSendText:text isReceive:NO showMike:NO showText:YES];
            model.toId = weakSelf.friendModel.userId;
            [weakSelf.messageView appendMessage:model];
            weakSelf.chatBottomView.nextGrowingTextView.textView.text = nil;
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [weakSelf.chatBottomView endEditing:YES];
            });
        }
    };
    self.moreBgView = [[UIView alloc] initWithFrame:CGRectZero];
    self.moreBgView.backgroundColor = self.chatBottomView.backgroundColor;
    [self addSubview:self.moreBgView];
    
    self.chatBottomView.moreBtnBtnBlock = ^(NSString * _Nonnull text) {
        [UIView animateWithDuration:.5 animations:^{
            if (text.length) {
                weakSelf.chatBottomView.transform = CGAffineTransformMakeTranslation(0,0);
                weakSelf.moreBgView.transform = CGAffineTransformMakeTranslation(0,0);
            }else {
                weakSelf.chatBottomView.transform = CGAffineTransformMakeTranslation(0,-80);
                weakSelf.moreBgView.transform = CGAffineTransformMakeTranslation(0,-80 - kSafeAreaBottom);
            }
        }];
    };
    self.chatBottomView.nextGrowingTextView.delegates = self;
    
    
    [self.moreBgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self);
        make.height.mas_equalTo(80);
        make.top.equalTo(self.mas_bottom).offset(0);
    }];
    NSArray *arr = @[[SLMikeSegmentModel initWithSegTitle:@"图片" segImage:@"icon_chat_b_tp"],
                     [SLMikeSegmentModel initWithSegTitle:@"拍照" segImage:@"icon_chat_b_xj"],
                     [SLMikeSegmentModel initWithSegTitle:@"视频聊天" segImage:@"icon_chat_b_sp"],
                     [SLMikeSegmentModel initWithSegTitle:@"语音聊天" segImage:@"icon_chat_b_yy"]];
    NSMutableArray *btns = [NSMutableArray array];
    [arr enumerateObjectsUsingBlock:^(SLMikeSegmentModel *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        [btn setTitle:obj.segTitle forState:UIControlStateNormal];
        [btn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        [btn setImage:ImageName(obj.segImage) forState:UIControlStateNormal];
        btn.titleLabel.font = [UIFont systemFontOfSize:12];
        [btn layoutButtonWithEdgeInsetsStyle:MKButtonEdgeInsetsStyleTop imageTitleSpace:3];
        [self.moreBgView addSubview:btn];
        [btns addObject:btn];
    }];
    [btns mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.height.equalTo(self.moreBgView);
    }];
    [btns mas_distributeViewsAlongAxis:MASAxisTypeHorizontal withFixedSpacing:0 leadSpacing:0 tailSpacing:10];
}

- (BOOL)pointInside:(CGPoint)point withEvent:(UIEvent *)event
{
    if (self.moreBgView.transform.ty != 0 && CGRectContainsPoint(CGRectInset(self.messageView.bounds, 0, 80), point)) {
        self.chatBottomView.moreBtnBtnBlock(@"11");
    }
    return YES;
}

#pragma mark - changeHeight
- (void)willChangeHeight:(CGFloat)height
{
    [self bottomChangeHeight:height];
}

- (void)didChangeHeight:(CGFloat)height
{
    [self bottomChangeHeight:height];
}

- (void)bottomChangeHeight:(CGFloat)height
{
    [self.chatBottomView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.height.mas_equalTo(kSafeAreaBottom + MAX(height + 16, 56));
    }];
    [self.chatBottomView setNeedsDisplay];
    [self.messageView scrollToBottom:NO];
    self.moreBgView.transform = CGAffineTransformMakeTranslation(0,0);
}

- (YMChatBottomView *)chatBottomView
{
    if (!_chatBottomView) {
        _chatBottomView = [[YMChatBottomView alloc] initWithFrame:CGRectZero];
        [self addSubview:_chatBottomView];
    }
    return _chatBottomView;
}

- (YMIMMessageCollectionView *)messageView
{
    if (!_messageView) {
        _messageView = [[YMIMMessageCollectionView alloc] initWithFrame:CGRectZero];
        [self addSubview:_messageView];
    }
    return _messageView;
}

@end
