//
//  SLInterestSelVc.m
//  SLAiELTS
//
//  Created by Gusont on 2023/7/5.
//

#import "SLInterestSelVc.h"
#import "SLInterestView.h"

@interface SLInterestSelVc ()

@property (nonatomic, strong)SLInterestView *interestView;

@end

@implementation SLInterestSelVc

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.title = NSLocalizedString(@"兴趣选择", nil);
    YMBarButtonItem *rightBarItem = [[YMBarButtonItem alloc] initWithTitle:NSLocalizedString(@"保存  ", nil) target:self action:@selector(preserveBtnClick)];
    rightBarItem.titleInsets = UIEdgeInsetsMake(0, 0, 0, 20);
    self.navigationBar.rightBarButtonItem = rightBarItem;
    
    self.interestView = [[SLInterestView alloc] initWithFrame:CGRectZero];
    [self.view addSubview:self.interestView];
    [self.interestView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.equalTo(self.view);
        make.top.mas_equalTo(kNavBarHeight);
    }];
    
    [[SLHttpCenter SharedInstance] getWithUrl:@"/api/User/GetInterestList" parameter:@{} success:^(id responseObject) {
        NSArray *interestList = [responseObject objectForKey:@"data"];
        NSArray *interestListModel = [InterestModel mj_objectArrayWithKeyValuesArray:interestList];
        NSArray *interestsArr = [SLGlobalInfo SharedInstance].loginInfo.user.interestsArr;
        [interestListModel enumerateObjectsUsingBlock:^(InterestModel *  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
            [interestsArr enumerateObjectsUsingBlock:^(InterestModel * _Nonnull obj1, NSUInteger idx, BOOL * _Nonnull stop1) {
                if ([obj.interestId isEqualToString:obj1.interestId]) {
                    obj.isSeleted = YES;
                    *stop1 = YES;
                }
            }];
        }];
        [self.interestView confignIntersetBtn:interestListModel];
    } failure:^(SPRequestError *error) {

    }];
}

- (void)preserveBtnClick {
    __block NSMutableString *interestStr = [NSMutableString string];
    NSMutableArray *marr = [NSMutableArray array];
    [self.interestView.interestArr enumerateObjectsUsingBlock:^(InterestModel * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        if (obj.isSeleted) {
            [interestStr appendString:[NSString stringWithFormat:@"%@,",obj.interestId]];
            [marr addObject:obj];
        }
    }];
    if (interestStr.length) {
        [[SLHttpCenter SharedInstance] postWithUrl:@"/api/User/AddUserInterest" parameter:@{@"interIds" : interestStr} success:^(id responseObject) {
            [ZFToast ShowWithMessage:NSLocalizedString(@"保存成功", nil)];
            SLLoginInfo *newLoginModel = [SLGlobalInfo SharedInstance].loginInfo;
            newLoginModel.user.interestsArr = marr;
            [SLGlobalInfo SharedInstance].loginInfo = newLoginModel;
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self.navigationController popViewControllerAnimated:YES];
            });
        } failure:^(SPRequestError *error) {

        }];
    }else {
        [ZFToast ShowWithMessage:NSLocalizedString(@"请选择兴趣标签", nil)];
    }
}

@end
